cc.FileUtils:getInstance():addSearchPath("src")
cc.FileUtils:getInstance():addSearchPath("res")

-- CC_USE_DEPRECATED_API = true
require "cocos.init"
require "socket"
require "sdk.sdkUtils"

json = require "cjson"

--DARKJOURNEY_SDK_TYPE = "ios"
DARKJOURNEY_SDK_TYPE = "android"
--DARKJOURNEY_SDK_TYPE = "appstore"
--DARKJOURNEY_SDK_TYPE = "taiwen"
DARKJOURNEY_SDK_CHANNEL_ID = 11111
DARKJOURNEY_CHANNEL_ID = 0

DARKJOURNEY_SERVER_SIGN = 0

device_info = {}
DARKJOURNEY_EXAMINE = false

--是否专服，1默认，20豌豆荚独代新口袋妖怪，22安卓新口袋妖怪...
DARKJOURNEY_IS_SPECIAL = 71
DARKJOURNEY_SPECIAL_NAME = {
    [1] = "奇迹西游",
    [2] = "西游传奇",
}

-- cclog
local cclog = function(...)
    print(string.format(...))
end

-- for CCLuaEngine traceback
function __G__TRACKBACK__(msg)
    cclog("----------------------------------------")
    cclog("LUA ERROR: " .. tostring(msg) .. "\n")
    cclog(debug.traceback())
    cclog("----------------------------------------")
    return msg
end

--function writeFile(fmt, ...)
--   local f = io.open("log.txt", 'a+')
--   if type(fmt) == "string" then
--       f:write(string.format(fmt, ...) .. "\n")
--   end
--   old_print(fmt, ...)
--   f:close()
--end

-- if DEBUG == 1 then
--   old_print = print
--   print = writeFile
--   print("\n" .. os.date() .. "\n")
-- end

local function main()
    sdkUtils.init()
    print("Wecome ! Now initialization....")

    collectgarbage("collect")
    -- avoid memory leak
    collectgarbage("setpause", 100)
    collectgarbage("setstepmul", 5000)

    -- initialize director
    local director = cc.Director:getInstance()

    --turn on display FPS
    director:setDisplayStats(false)

    --set FPS. the default value is 1.0/60 if you don't call this
    director:setAnimationInterval(1.0 / 50)
    
    director:getOpenGLView():setDesignResolutionSize(640, 1136, cc.ResolutionPolicy.EXACT_FIT)
    
    MainScene = require("core.scene.MainScene")
    MainScene.new()
    
    if cc.Director:getInstance():getRunningScene() then
        cc.Director:getInstance():replaceScene(MainScene.Instance)
    else
        cc.Director:getInstance():runWithScene(MainScene.Instance)
    end
    
    --获取平台信息
    local platform = cc.Application:getInstance():getTargetPlatform()
    if (cc.PLATFORM_OS_IPHONE == platform or cc.PLATFORM_OS_IPAD == platform) and DARKJOURNEY_SDK_TYPE ~= "appstore" then
        luaoc = luaoc or require("cocos.cocos2d.luaoc")
        local result, deviceInfo = luaoc.callStaticMethod("Sdk", "getInfo", {})
        if result then
            DARKJOURNEY_SDK_TYPE = deviceInfo["DARKJOURNEY_SDK_TYPE"]
            DARKJOURNEY_SDK_CHANNEL_ID = tonumber(deviceInfo["DARKJOURNEY_SDK_CHANNEL_ID"])
        end
    end

    local launcher = require("Launcher")
    launcher.init()
    
    if not cc.UserDefault:getInstance():getBoolForKey("is_delete_server_list") then
        for var=1, 3 do
            cc.UserDefault:getInstance():setStringForKey("last_login_server"..var, "0")
        end
        
        cc.UserDefault:getInstance():setBoolForKey("is_delete_server_list", true)
    end

    if platform == cc.PLATFORM_OS_ANDROID then
        if DARKJOURNEY_SDK_TYPE == "android" then
            luaj = luaj or require("cocos.cocos2d.luaj")
            local ok, ret = luaj.callStaticMethod("org.cocos2dx.lua.AppActivity", "getChannelID", {}, "()Ljava/lang/String;")
            if ok then
                DARKJOURNEY_SDK_CHANNEL_ID = tonumber(ret)
            end
        end
    end
    
    if DARKJOURNEY_SDK_TYPE == "appstore" then
        luaoc = luaoc or require("cocos.cocos2d.luaoc")
        local _result
        _result, device_info  = luaoc.callStaticMethod("Sdk", "getInfo", nil)
        if _result then
            device_info.ip = string.gsub(device_info.ip, "\n", "")
            for key, var in pairs(device_info) do
                print(key, var)
            end
        else
            local function _fail()
                endToLua()
            end
            require("common.Alert")
            Alert:getInstance():showAlert("初始化游戏失败，请重启游戏", "提  示", 1, _fail, nil, nil, nil, nil, true)
            return
        end
        
--        local rt = cc.UserDefault:getInstance():getStringForKey("restart_time")
        local function _active()
            local _t = {}
            _t.DATA = {}
            
            _t.DATA.ACTIONTYPE = "START"
            _t.DATA.SCENENAME = device_info.name
            _t.DATA.EVENTTAG = "ACTIVATION"
            
            local _str = device_info.adId
            _str = _str.."###"..device_info.identifier
            _str = _str.."###"..device_info.udid
            
            _t.DEVICEINFO = {}
            _t.DEVICEINFO.SCREENSIZE = device_info.screen
            _t.DEVICEINFO.DEVICEID = _str
            _t.DEVICEINFO.CHANNEL = DARKJOURNEY_SDK_TYPE
            _t.DEVICEINFO.LOCATION = ""
            _t.DEVICEINFO.TIME = os.time()
            _t.DEVICEINFO.NETWORKSTATUS = "undefine"
            _t.DEVICEINFO.DEVICENAME = device_info.systemName
            _t.DEVICEINFO.IMSI = device_info.udid
            _t.DEVICEINFO.APPID = "100000011"
            _t.DEVICEINFO.IPADDRESS = device_info.ip
            _t.DEVICEINFO.SYSTEMVERSION = device_info.systemVersion
            
            local cjson = require "cjson"
            local _j = cjson.encode(_t)

            local xhr = cc.XMLHttpRequest:new() -- http请求
            xhr.responseType = cc.XMLHTTPREQUEST_RESPONSE_JSON -- 响应类型
            xhr.timeout = 5000

            local _url = "http://api.ijunhai.com/data/getTjData"
            xhr:open("POST", _url) -- 打开链接

            xhr:send("tj_data=".._j) -- 发送请求    
        end
        
        _active()
--        if not rt or rt == "" then
--            cc.UserDefault:getInstance():setStringForKey("restart_time", os.time())
--            cc.UserDefault:getInstance():flush()
--            _active()
--        else
--            local _time = os.time()
--            if _time > tonumber(rt) then
--                if os.date("%Y/%m/%d", tonumber(_time)) ~= os.date("%Y/%m/%d", tonumber(rt)) then
--                    cc.UserDefault:getInstance():setStringForKey("restart_time", _time)
--                    cc.UserDefault:getInstance():flush()
--                    _active()
--                end
--            end
--        end
    end
end

function getServerList(cb, id)
    if not Get_Server then
    	require "GetServerList"
        Get_Server = GetServerList.new(cb, id)
    else
        Get_Server:init(cb, id)
    end
end

function UpdateEnd()
    require "GameContrl"
    MainScene.Instance:initScene()
    GameContrl.new()
end

function OnNetAsyncConnected(is_suc, handle, netid)
--    print("!!!!!!!!OnNetAsyncConnected!!!", is_suc, handle, netid)
    local my_is_suc = is_suc and "true" or "false"
    GameContrl.OnAsyncConnected(is_suc, handle, netid)
end

function endToLua()
	cc.Director:getInstance():endToLua()
	local platform = cc.Application:getInstance():getTargetPlatform()
	if platform == cc.PLATFORM_OS_IPHONE or platform == cc.PLATFORM_OS_IPAD then
        os.exit()
	end
end

function OnNetRecv(msg_type, net_id)
--    print("!!!!!", msg_type, net_id)
    GameContrl.OnNetRecv(msg_type, net_id)
end

function OnNetDisconnect(net_id)
    GameContrl.OnNetDisconnect(net_id)
end

local status, msg = xpcall(main, __G__TRACKBACK__)
if not status then
    error(msg)
end